/******************************************************************************
This file is part of WhiteStork.

WhiteStork is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

WhiteStork is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with WhiteStork; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

Copyright 2006 ComArch S.A.
******************************************************************************/

// header with data structure and function definition for XDXF engine.
// Also Engine API. 
#include <engine_bookmark.h>
//------------------------------------------------------------------------------

#ifndef NOLOGS
#include <glib/gstdio.h>
#include <string.h>
#include <stdlib.h>
#endif

#define LOGS g_debug

/*inline void LOGS(gchar* frm, ...) {
#ifndef NOLOGS
	//g_printf(frm);
#endif
}*/

//==============================================================================
//==============================================================================
//==============================================================================
//-------------------------------------- FUNCTION FROM API 0.2 !!!
//==============================================================================
int get_id(void* data,int n,char** argv,char** names) {
        int len = strlen(&(argv[0][0]));
        memcpy(data,&(argv[0][0]), len);
        gchar* tmp = (gchar*)data;
        tmp[len] = 0;
        return 0;
}

gboolean bm_engine_add_word(Engine* engine,
                         gchar*  word,
                         gchar*  translation) {
        gint sql_res = 0;
        gchar* err = NULL;
        gboolean result = TRUE;
        gchar* sql = NULL;

        LOGS("Bookmark/%s->%s() called. Param\nEngine at address: %p\n"
             "word: %s\ntranslation address: %p\n",
             (gchar*)__FILE__,
             (gchar*)__FUNCTION__,
             engine,
             word,
             translation
            );
        g_assert(engine != NULL);
        g_assert(word != NULL);
        g_assert(translation != NULL);

        // start timer for this function
        timer(TIMER_START, (gchar*)(gchar*)__FUNCTION__);

	BookData* data = (BookData*)(engine->engine_data);
/*

        gchar* tmp = g_utf8_strdown(word,-1);
        sql = g_strconcat("INSERT INTO words VALUES(NULL,\'",tmp,"\');",NULL);
        sql_res = sqlite_exec(data->db, sql, NULL, NULL, &err);
        if(err || sql_res!=0) {
                LOGS("This word exists already\nError description: %s\n",err);
        }            
        g_free(sql); sql = NULL;
        const gchar* end;
        sqlite_vm* query = NULL;

        sql = g_strconcat("SELECT id FROM words WHERE word=\'",tmp,"\'",NULL);
        gchar word_id[20];
        sqlite_exec(
                (data->db),
                sql,
                get_id,
                word_id,
                &err
        );
        LOGS("Founded id is equal: %s\n",word_id);
*/
        //sql = g_strconcat("INSERT INTO translations VALUES(NULL,\'",word,"\',\'",translation,"\');",NULL);
	sql = sqlite_mprintf("INSERT INTO translations VALUES(NULL,\'%q\',\'%q\');", word, translation);

        sql_res = sqlite_exec(data->db, sql, NULL, NULL, &err);
        if(err || sql_res!=0) {
                LOGS("Error while adding translation for word %s\n"
		     "Reason: %s",
		     word,
		     err
		    );
                result = FALSE;
        } 
        g_free(sql); sql = NULL;

        timer(TIMER_STOP, (gchar*)(gchar*)__FUNCTION__);
        return result;
}
//------------------------------------------------------------------------------
gboolean bm_engine_remove_word(Engine* engine, gchar*  word) {
        gint sql_res = 0;
        gchar* err = NULL;
        gboolean result = TRUE;

        LOGS("Bookmark/%s->%s() called. Param\nEngine at address: %p\n"
             "word: %s\n",(gchar*)__FILE__,(gchar*)__FUNCTION__,engine,word);
        g_assert(engine != NULL);
        g_assert(word != NULL);
        timer(TIMER_START, (gchar*)(gchar*)__FUNCTION__);

        BookData* data = (BookData*)(engine->engine_data);
/*
        gchar* tmp = g_utf8_strdown(word,-1);
        gchar* sql = g_strconcat("DELETE FROM translations WHERE word_id = "
                                 "(SELECT id FROM words WHERE word=\'",
                                 tmp,
                                 "\');",
                                 NULL
                                );
        g_free(tmp); tmp = NULL;
        sql_res = sqlite_exec(data->db, sql, NULL, NULL, &err);
        if(err || sql_res!=0) {
                LOGS("Error while deleting \'%s\' word translation(s):\n%s\n",word,err);
                g_free(sql); sql = NULL;
                return FALSE;
        }        
        g_free(sql); sql = NULL;

        gchar* sql = g_strconcat("DELETE FROM translations WHERE word LIKE \'",
                                 word,
                                 "\';",
                                 NULL
                                );
*/
	gchar* sql = sqlite_mprintf("DELETE FROM translations WHERE word LIKE "
					"\'%q\';", word);
	sql_res = sqlite_exec(data->db, sql, NULL, NULL, &err);
        if(err || sql_res!=0) {
                LOGS("Error while deleting \'%s\' <-> reason:\n%s\n",word,err);
                g_free(sql); sql = NULL;
                return FALSE;
        }
        g_free(sql); sql = NULL;

        timer(TIMER_STOP, (gchar*)(gchar*)__FUNCTION__);
        return result;
}
//------------------------------------------------------------------------------      
gchar* bm_engine_get_lang_from(Engine* engine) {
        LOGS("Bookmark/%s->%s() called.\n",(gchar*)__FILE__,(gchar*)__FUNCTION__);
        gchar* result = g_strdup("any");
        LOGS("Bookmark/%s->%s() return string=%s\n",
                (gchar*)__FILE__,
                (gchar*)__FUNCTION__,
                result
               );
        return result;
}
//------------------------------------------------------------------------------
gchar* bm_engine_get_lang_to(Engine* engine) {
        LOGS("Bookmark/%s->%s() called.\n",(gchar*)__FILE__,(gchar*)__FUNCTION__);
        gchar* result = g_strdup("any");
        LOGS("Bookmark/%s->%s() return string=%s\n",
                (gchar*)__FILE__,
                (gchar*)__FUNCTION__,
                result
               );
        return result;
}
//------------------------------------------------------------------------------
gchar* bm_engine_get_title(Engine* engine) {
        LOGS("Bookmark/%s->%s() called.\n",(gchar*)__FILE__,(gchar*)__FUNCTION__);
        gchar* result = g_strconcat(g_get_user_name(),"s' bookmarks",NULL);
        LOGS("Bookmark/%s->%s() return string=%s\n",
                (gchar*)__FILE__,
                (gchar*)__FUNCTION__,
                result
               );
        return result;
}
//------------------------------------------------------------------------------
gchar* bm_engine_get_icon_path(Engine* engine) {
        LOGS("Bookmark/%s->%s() called.\n",(gchar*)__FILE__,(gchar*)__FUNCTION__);
        gchar* result = g_strdup("/usr/share/pixmaps/ws_eng_bookmark_icon.png");
        LOGS("Bookmark/%s->%s() return string=%s\n",
                (gchar*)__FILE__,
                (gchar*)__FUNCTION__,
                result
               );
        return result;
}

//==============================================================================
//==============================================================================
//==============================================================================
//-------------------------------------- FUNCTION TO WRITE (NOT IMPLEMENTED YET)
//==============================================================================

//------------------------------------------------------------------------------
// searching word by concrete engine
void bm_engine_search_word_translation(Engine* engine, gchar* word)
{
        LOGS("Bookmark/%s->%s() called.\n-->PARAM:engine at adress=%p\n"
             "-->PARAM:word=\'%s\'\n",
             (gchar*)__FILE__,
             (gchar*)__FUNCTION__,
             engine,
             word
            );
        g_assert(engine != NULL);
        g_assert(word != NULL);
        // start timer for this function
        timer(TIMER_START, (gchar*)(gchar*)__FUNCTION__);
	BookData* data = (BookData*)(engine->engine_data);
	//gchar* tmp = g_utf8_strdown(word,-1);
        sqlite_vm* query;
        gchar* sql = NULL;
        gchar* tran = NULL;

/*
        sql = g_strconcat("SELECT * FROM translations WHERE "
                          "word_id=(SELECT id FROM words WHERE word=\'",
                          tmp,
                          "\');",
                          NULL);
*/

        /*sql = g_strconcat("SELECT * FROM translations WHERE word LIKE \'",
                          tmp,
                          "\';",
                          NULL);*/
	sql = sqlite_mprintf("SELECT translation FROM translations WHERE word LIKE '%q';",
				word);

        gint sql_res = 0;
        const gchar* end;
        gchar* err = NULL;
        sql_res = sqlite_compile(data->db,  /* The open database */
                                 (const gchar*)sql, /* SQL statement to be compiled */
                                 &end,      /* OUT: uncompiled tail of zSql */
                                 &query,    /* OUT: the virtual machine */
                                 &err       /* OUT: Error message. */
                                );
        if(err || sql_res!=0) {
                LOGS("Error while compiling query:\n%s\nreason:%s\n",sql,err);
                sqlite_freemem(sql);/*g_free(sql);*/ sql = NULL;
                return;
        }

        gint nCol = 0;
        const gchar** values = NULL;
        const gchar** head = NULL;
        gint status = 0;
        gboolean first = TRUE;
        do { 
                first = TRUE;
                do {
                        if(!first) sleep(1);
                        first = FALSE;
                        status = sqlite_step(query,
                                        &nCol,
                                        &values,
                                        &head 
                                        );
                        if(status == SQLITE_ROW) {
				if (tran != NULL){
					tran = g_strconcat(tran,"<BR><BR>", 
						(gchar*)(&(values[0][0])), NULL);	
				}else{
					tran = g_strdup_printf("%s <BR><BR>",
						(gchar*)(&(values[0][0])));
				}
				LOGS("Translation found :\n\"%s\"\n",tran);
                        }
                } while((status == SQLITE_BUSY) && (status != SQLITE_ERROR));
        } while((status == SQLITE_ROW) && (status != SQLITE_ERROR));
        sqlite_finalize(query,&err);
        sqlite_freemem(sql); sql = NULL;
        timer(TIMER_STOP,(gchar*)(gchar*)__FUNCTION__);
        timer(TIMER_START,"callback for returning word's translation START");
        // calling callback for word translation

        data->cb_search_word_trans(tran, word, data->cb_search_word_trans_data,
					 ENGINE_NO_ERROR);
		
        timer(TIMER_STOP,"callback for returning word's translation END");
        if(data->auto_free) {
                LOGS("Bookmark/%s->%s() deleting all dynamic data because "
                     "AUTO_FREE=TRUE\n",
                     (gchar*)__FILE__,
                     (gchar*)__FUNCTION__
                    );
                g_free(tran);
        }
        tran = NULL;
}

//------------------------------------------------------------------------------
void bm_engine_close(Engine* engine)
{
        LOGS("Bookmark/%s->%s() called.\n-->PARAM: engine adress=%p\n",
                (gchar*)__FILE__,
                (gchar*)__FUNCTION__,
                engine);
        g_assert(engine != NULL);
        
        BookData* data = (BookData*)(engine->engine_data);
        sqlite_close(data->db);
        
        LOGS("Bookmark/%s->%s() engine at adress=%p is deleted.\n",
                (gchar*)__FILE__,
                (gchar*)__FUNCTION__,
                engine);
        g_free(engine);
        engine = NULL;
}
//------------------------------------------------------------------------------

Engine* bm_engine_create(gchar* location,
                      EngineOptimizationFlag auto_cache,
                      cb_progress progress_handler,
                      gpointer progress_data,
                      gdouble seed)
{
        LOGS("Bookmark/%s->%s() called.\n"
             "-->PARAM:location=\'%s\'\n"
             "-->PARAM:auto_cache=%d\n",
             (gchar*)__FILE__,
             (gchar*)__FUNCTION__,
             location,
             (guint)auto_cache
            );
        timer(TIMER_START,(gchar*)(gchar*)__FUNCTION__);        
        gchar* tmp = g_strdup(location);
        string_to_path(&tmp);

        Engine* result = (Engine*)g_try_malloc(sizeof(Engine));
        result->engine_location = bm_engine_location;
        result->engine_is_optimized = bm_engine_is_optimized;
        result->engine_optimize = bm_engine_optimize;
        result->engine_search_word_list = bm_engine_search_word_list;
        result->engine_search_word_translation = 
                        bm_engine_search_word_translation;        
        result->engine_close = bm_engine_close;
        result->engine_status = bm_engine_status;
        result->engine_error_message = bm_engine_status_message;
        result->engine_set_callback = bm_engine_set_callback;
        result->engine_set_progress_seed = bm_engine_set_progress_seed;
        result->engine_set_auto_free = bm_engine_set_auto_free;
        // 0.2 API:
        result->engine_add_word = bm_engine_add_word;
        result->engine_remove_word = bm_engine_remove_word;
        result->engine_get_lang_from = bm_engine_get_lang_from;
        result->engine_get_lang_to = bm_engine_get_lang_to;
        result->engine_get_title = bm_engine_get_title;
        result->engine_get_icon_path = bm_engine_get_icon_path;


        BookData* data = (BookData*)g_try_malloc(sizeof(BookData));
        result->engine_data = (gpointer)data;

        LOGS("Bookmark/%s->%s() opening file...\'%s\'.\n",
             (gchar*)__FILE__,
             (gchar*)__FUNCTION__,
             location
            );
        gchar* tmp2 = g_strconcat(tmp,"/ws_bookmarks",NULL);
        gchar* err;
        data->db = sqlite_open(tmp2,0600,&err);
        g_free(tmp2); tmp2 = NULL;
        if(!(data->db)) {
                LOGS("Bookmark/%s->%s() opening bookmark file failed.%s\n",
                     (gchar*)__FILE__,
                     (gchar*)__FUNCTION__,
                     err
                    );
                g_free(err);
                g_free(data);
                g_free(result);
                result = NULL;
        }
        else {
                LOGS("Bookmark/%s->%s()opening dictionary file successed.\n",
                        (gchar*)__FILE__,
                        (gchar*)__FUNCTION__
                       );
                data->dict_path = g_strdup(tmp);
                data->cb_progress_caching = progress_handler;
                data->cb_progress_caching_data = progress_data;        
                data->cb_progress_caching_seed = seed;        
                data->cb_progress_word_list = NULL;
                data->cb_progress_word_list_data = NULL;
                data->cb_progress_word_list_seed = 0.01;
                data->cb_progress_word_trans = NULL;
                data->cb_progress_word_trans_data = NULL;
                data->cb_progress_word_trans_seed = 0.01;

                data->cb_search_word_list = NULL;
                data->cb_search_word_list_data = NULL;

                data->cb_search_word_trans = NULL;
                data->cb_search_word_trans_data = NULL;

                data->auto_free = FALSE;
                // there is no cache mechanizm in bookmarks
        }
        g_free(tmp); tmp = NULL;
        
        timer(TIMER_STOP,(gchar*)(gchar*)__FUNCTION__);
        LOGS("Bookmark/%s->%s() returned Engine at adress=%p\n",
             (gchar*)__FILE__,
             (gchar*)__FUNCTION__,
             result
            );
        return result;
}
//------------------------------------------------------------------------------



static gboolean is_Bookmark_file(gchar* file) {
        LOGS("Bookmark/%s->%s() called.\n\
                 -->PARAM:file=\'%s\'\n",
                 (gchar*)__FILE__,
                 (gchar*)__FUNCTION__,
                 file
               );
        gchar* err;
        sqlite* tmp = sqlite_open(file,0600,&err);
        if(err || tmp==NULL) {
                LOGS("Wrong file! Not a sqlite database.\n");
                g_free(err); 
                return FALSE;
        }

        gint result = 0;
        gchar sql[] = "SELECT COUNT(word) FROM translations WHERE word=\'.\';";  

        result = sqlite_exec(tmp, sql, NULL, NULL, &err);
        if(err || result!=0) {
                LOGS("Wrong database! Not a bookmark.\n");
                g_free(err);
		sqlite_close(tmp);
                return FALSE;
        }
	sqlite_close(tmp);
        return TRUE;
}
//------------------------------------------------------------------------------


void bm_engine_optimize(Engine* engine)
{
        LOGS("Bookmark/%s->%s() called for engine at adress=%p\n",
             (gchar*)__FILE__,
             (gchar*)__FUNCTION__,
             engine
            );
        LOGS("Unsupported optimization mechanizm for this engine!\n");
        LOGS("Bookmark/%s->%s()'s work finished.\n",(gchar*)__FILE__,(gchar*)__FUNCTION__);
}
//------------------------------------------------------------------------------
gboolean bm_engine_check(gchar* location) 
{        
        LOGS("Bookmark/%s->%s() called.\n-->PARAM:location=\'%s\'\n",
             (gchar*)__FILE__,
             (gchar*)__FUNCTION__,
             location
            );
        timer(TIMER_START,(gchar*)(gchar*)__FUNCTION__);
        gboolean result = TRUE;        
        gchar* filepath = g_strdup(location);
        gchar* tmp = NULL;
        string_to_path(&filepath);
        if (filepath == NULL) {
                result = FALSE;
                LOGS("Bookmark/%s->%s() location \'%s\' is not a proper "
                     "path!\n",
                     (gchar*)__FILE__,
                     (gchar*)__FUNCTION__,
                     location
                    );
        }
        else {
                tmp = g_strconcat(filepath,"/ws_bookmarks",NULL);
                g_free(filepath);
                filepath = tmp;
                tmp = NULL;

                LOGS("Bookmark/%s->%s() finnal file to check is: %s\n",
                     (gchar*)__FILE__,
                     (gchar*)__FUNCTION__,
                     filepath
                    );
                if (!g_file_test(filepath, G_FILE_TEST_IS_REGULAR)) {
                        LOGS("Bookmark/%s->%s() file \'%s\' does not exists!\n",
                             (gchar*)__FILE__,
                             (gchar*)__FUNCTION__,
                             filepath
                            );
                        result = FALSE;
                };
        };
        if (result != FALSE) {
                result = is_Bookmark_file(filepath);
        };

        g_free(filepath);
        timer(TIMER_STOP,(gchar*)(gchar*)__FUNCTION__);
        LOGS("Bookmark/%s->%s() returned bool statement=%s.\n",
             (gchar*)__FILE__,
             (gchar*)__FUNCTION__,
             PRINT_STATE(result)
            );
        return result;
}

//------------------------------------------------------------------------------
gboolean bm_engine_is_optimized(Engine* engine) 
{
        LOGS("Bookmark/%s->%s() called.\n-->PARAM: engine adress=%p\n",
             (gchar*)__FILE__,
             (gchar*)__FUNCTION__,
             engine
            );
        g_assert(engine != NULL);                
        gboolean result = FALSE;
        LOGS("Bookmark/%s->%s() returned bool statement=%s.\n",
             (gchar*)__FILE__,
             (gchar*)__FUNCTION__,
             PRINT_STATE(result)
            );
        return result;
}
//------------------------------------------------------------------------------

void bm_engine_search_word_list(Engine* engine, gchar* pattern)
{
        LOGS("Bookmark/%s->%s() called. Searching words list\n"
             "-->PARAM:engine at adress=%p\n"
             "-->PARAM:pattern=\"%s\"\n",
             (gchar*)__FILE__,
             (gchar*)__FUNCTION__,
             engine,
             pattern
            );
        g_assert(engine != NULL);
        g_assert(pattern != NULL);

        timer(TIMER_START,(gchar*)(gchar*)__FUNCTION__);
        BookData* data = (BookData*)(engine->engine_data);
        if(data->cb_search_word_list == NULL) {
                LOGS("Bookmark/%s->%s() callback for Word List not set. "
                     "Searching aborted.\n",
                     (gchar*)__FILE__,
                     (gchar*)__FUNCTION__
                    );
                timer(TIMER_STOP,(gchar*)(gchar*)__FUNCTION__);
                return;
        };
 

        gchar* tmp = g_utf8_strdown(pattern,-1);
        sqlite_vm* query = NULL;
        gchar* sql = NULL;
        gchar* tran = NULL;

	//LOGS("::::BOOKMARKS!!!!:::: tmp = %s, int(tmp) = %i", tmp, tmp[0]);


	g_strstrip(tmp);
	if ((int)(tmp[0]) == 42 && tmp[1] == '\0') //asterix?
	{
		sql = g_strconcat("SELECT DISTINCT word FROM translations;", NULL);
	}
	else
	{
       		sql = g_strconcat("SELECT word FROM translations WHERE "
                          "word LIKE \'",tmp,"\%\';",NULL);
	}
        LOGS("QUERY: %s\n",sql);
        gint sql_res = 0;
        const gchar* end;
        gchar* err = NULL;
        sql_res = sqlite_compile(data->db,  /* The open database */
                                 (const gchar*)sql,       /* SQL statement to be compiled */
                                 &end,      /* OUT: uncompiled tail of zSql */
                                 &query,    /* OUT: the virtual machine */
                                 &err       /* OUT: Error message. */
                                );
        if(err || sql_res!=0) {
                LOGS("Error while compiling query:\n%s\nreason:%s\n",sql,err);
                g_free(sql); sql = NULL;
                return;
        };    
        gint nCol = 0;
        const gchar** values = NULL;
        const gchar** head = NULL;
        gint status = 0;
        gboolean first = TRUE;
        GArray* result = g_array_new(TRUE, TRUE, sizeof(gchar*) );
        do { 
                first = TRUE;
                do {
                        if(!first) sleep(1);
                        first = FALSE;;
                        status = sqlite_step(
                                        query, 
                                        &nCol,            
                                        &values,  
                                        &head 
                                        );
                        if(status == SQLITE_ERROR) {
                                LOGS("Error while making next step\n");
                                g_free(sql); sql = NULL;
                                        return;
                        };
                        if(status == SQLITE_ROW) {
                                LOGS("Fount new word: \"%s\"\n",&(values[0][0]));
                                gchar* tmp = g_strdup((gchar*)&(values[0][0]));
                                g_array_append_val(result, tmp );        
                        }
                } while((status == SQLITE_BUSY) && (status != SQLITE_ERROR));
        } while((status == SQLITE_ROW) && (status != SQLITE_ERROR));
        sqlite_finalize(query,&err);
        timer(TIMER_STOP,(gchar*)(gchar*)__FUNCTION__);


        timer(TIMER_START,"callback for returning words LIST START");
        // calling callback for word translation

        data->cb_search_word_list(result , pattern, data->cb_search_word_list_data, ENGINE_NO_ERROR);
                
        timer(TIMER_STOP,"callback for returning word LIST END");
        if(data->auto_free) {
                LOGS("Bookmark/%s->%s() deleting all dynamic data because "
                     "AUTO_FREE=TRUE\n",
                     (gchar*)__FILE__,
                     (gchar*)__FUNCTION__
                    );
                g_free(tran);
        }
}

//==============================================================================
//==============================================================================
//==============================================================================
//---------------------------------------------------------- COMPLETED FUNCTIONS
//==============================================================================
// global functions
EngineModule engine_global_functions()
{
	LOGS("Bookmark/%s->%s() called.\n",(gchar*)__FILE__,(gchar*)__FUNCTION__);
	EngineModule result;        
	result.engine_check             = bm_engine_check;
	result.engine_description       = bm_engine_description;
	result.engine_format            = bm_engine_format;
	result.engine_version           = bm_engine_version;
	result.engine_create            = bm_engine_create;
	LOGS("Bookmark/%s->%s()returned EngineModule at adress=%p.\n",
	     (gchar*)__FILE__,
	     (gchar*)__FUNCTION__,
             &result
	    );
	return result;
}
//------------------------------------------------------------------------------
// for macro: dict_eng_status_message(error)
gchar* bm_engine_status_message(EngineStatus error) 
{
	LOGS("Bookmark/%s->%s() called.\n",(gchar*)__FILE__,(gchar*)__FUNCTION__);
	switch (error) {
		case ENGINE_NO_ERROR:
			return "No error.";
		case ENGINE_WRONG_FILE:
			return "File which You are trying to use is wrong type.";
		case ENGINE_COULDNT_READ:
			return "Could not read from file.";
		case ENGINE_NO_FILE:
			return "There is no such a file.";
		case ENGINE_OUT_OF_MEMORY:
			return "There were no enough memory for this action.";
		default:
			return "Wrong engine's status identifier!";
	}
}
//------------------------------------------------------------------------------
// for macro: dict_eng_module_get_version(module)
gchar* bm_engine_version() 
{
	LOGS("Bookmark/%s->%s() called.\n",(gchar*)__FILE__,(gchar*)__FUNCTION__);
	gchar* result = g_strdup(DIC_ENG_VERSION);
	LOGS("Bookmark/%s->%s() return string=%s\n",
		(gchar*)__FILE__,
		(gchar*)__FUNCTION__,
		result
	       );
	return result;
}
//------------------------------------------------------------------------------
// for macro: dict_eng_module_get_format(module)
gchar* bm_engine_format() 
{
	LOGS("Bookmark/%s->%s() called.\n",(gchar*)__FILE__,(gchar*)__FUNCTION__);
	gchar* result = g_strdup(DIC_ENG_FORMAT);
	LOGS("Bookmark/%s->%s() return string=%s\n",
	     (gchar*)__FILE__,
	     (gchar*)__FUNCTION__,
	     result
	    );
	return result;
}
//------------------------------------------------------------------------------
// for macro: dict_eng_module_get_description(module)
gchar* bm_engine_description() 
{
	LOGS("Bookmark/%s->%s() called.\n",(gchar*)__FILE__,(gchar*)__FUNCTION__);
	gchar* result = g_strdup(DIC_ENG_DESCRIPTION);
	LOGS("Bookmark/%s->%s() return string=%s\n",
	     (gchar*)__FILE__,
	     (gchar*)__FUNCTION__,
	     result
	    );
	return result;
}
//------------------------------------------------------------------------------
// for macro: dict_eng_get_location(engine)
gchar* bm_engine_location(Engine* engine)
{
	LOGS("Bookmark/%s->%s() called.\n-->PARAM: engine adress=%p\n",
	     (gchar*)__FILE__,
	     (gchar*)__FUNCTION__,
	     engine
	    );
	g_assert(engine != NULL);
	BookData* data = (BookData*)(engine->engine_data);
        
	gchar* result;
	if(data->auto_free) {
		result = data->dict_path;
	}
	else {
		result = g_strdup(data->dict_path);
	}

	LOGS("Bookmark/%s->%s() returned string=%s\n",
	     (gchar*)__FILE__,
	     (gchar*)__FUNCTION__,
	     result
	    );
	return result;
}
//------------------------------------------------------------------------------
// for macro: dict_eng_set_auto_free(engine, state)
void bm_engine_set_auto_free(Engine* engine, gboolean state) 
{
	LOGS("Bookmark/%s->%s() called.\n"
	     "-->PARAM:engine at adress=%p\n"
	     "-->PARAM:state=%s\n",
	     (gchar*)__FILE__,
	     (gchar*)__FUNCTION__,
	     engine,
	     PRINT_STATE(state)
	    );
	g_assert(engine != NULL);
	BookData* data = (BookData*)(engine->engine_data);
        
	data->auto_free = state;
	LOGS("Bookmark/%s->%s() Current auto_free is %s\n",
	     (gchar*)__FILE__,
	     (gchar*)__FUNCTION__,
	     PRINT_STATE(data->auto_free)
	    );
}
//------------------------------------------------------------------------------
// for macro: dict_eng_get_last_status(engine)
EngineStatus bm_engine_status(Engine* engine) 
{
	LOGS("Bookmark/%s->%s() called.\n"
		"-->PARAM:engine at adress=%p\n",
		(gchar*)__FILE__,
		(gchar*)__FUNCTION__,
	       engine
	       );
	BookData* data = (BookData*)(engine->engine_data);
	LOGS("Bookmark/%s->%s() returned error code: %d\n",
	     (gchar*)__FILE__,
	     (gchar*)__FUNCTION__,
	     (gint)(data->last_error)
	    );        
	return data->last_error;
}
//------------------------------------------------------------------------------
// for macro: dict_eng_set_progress_seed(engine, signal, val)
void bm_engine_set_progress_seed(Engine* engine, gchar* signal, gdouble seed) {
	LOGS("Bookmark/%s->%s() called.\n",(gchar*)__FILE__,(gchar*)__FUNCTION__);
	BookData* data = (BookData*)(engine->engine_data);
	if(g_ascii_strcasecmp(signal,ENGINE_PROGRESS_OPTIMIZING_SIGNAL) == 0)  {
		data->cb_progress_caching_seed = seed;
		LOGS("Bookmark/%s->%s() sets new seed=%0.2f for for signal "
		     "\"%s\".\n",
		     (gchar*)__FILE__,
		     (gchar*)__FUNCTION__,
		     seed,
		     signal
		    );        
	} 
	else {
		LOGS("Bookmark/%s->%s() unsupported signalfor progress: %s.\n",
		     (gchar*)__FILE__,
		     (gchar*)__FUNCTION__,
		     signal
	            );
	};
}
//------------------------------------------------------------------------------
// for macro: dict_eng_set_callback(engine,signal,c_handler,data)
gpointer bm_engine_set_callback(Engine* engine,
			     gchar* signal,
			     gpointer c_handler,
			     gpointer user_data)
{
	LOGS("Bookmark/%s->%s() called.\n",(gchar*)__FILE__,(gchar*)__FUNCTION__);
	g_assert(engine != NULL);
	g_assert(signal != NULL);
	g_assert(c_handler != NULL);
	BookData* data = (BookData*)(engine->engine_data);
	if(g_ascii_strcasecmp(signal,ENGINE_PROGRESS_OPTIMIZING_SIGNAL) == 0)  {
		gpointer result = data->cb_progress_caching;
		data->cb_progress_caching = c_handler;
		data->cb_progress_caching_data = user_data;
		LOGS("Bookmark/%s->%s() sets handler for signal \"%s\".\n",
			(gchar*)__FILE__,
			(gchar*)__FUNCTION__,
			signal
		       );
		LOGS("Bookmark/%s->%s() Function at adress =  %d.\n",
			(gchar*)__FILE__,
			(gchar*)__FUNCTION__,
			(guint)c_handler
		       );
		LOGS("Bookmark/%s->%s()     Data at adress =  %d.\n",
			(gchar*)__FILE__,
			(gchar*)__FUNCTION__,
			(guint)user_data
		       );
		return result;                
	}
	else if(g_ascii_strcasecmp(signal, ENGINE_WORD_LIST_SIGNAL) == 0) {
		gpointer result = data->cb_search_word_list;
		data->cb_search_word_list = c_handler;
		data->cb_search_word_list_data = user_data;
		LOGS("Bookmark/%s->%s() sets handler for signal \"%s\".\n",
			(gchar*)__FILE__,
			(gchar*)__FUNCTION__,
			signal
		       );
		LOGS("Bookmark/%s->%s() Function at adress =  %d.\n",
			(gchar*)__FILE__,
			(gchar*)__FUNCTION__,
			(guint)c_handler
		       );
		LOGS("Bookmark/%s->%s()     Data at adress =  %d.\n",
			(gchar*)__FILE__,
			(gchar*)__FUNCTION__,
			(guint)user_data
		       );
		return result;                        
	}
	else if(g_ascii_strcasecmp(signal,
		ENGINE_WORD_TRANSLATION_SIGNAL) == 0)  {
			gpointer result = data->cb_search_word_trans;
			data->cb_search_word_trans = c_handler;
			data->cb_search_word_trans_data = user_data;
			LOGS("Bookmark/%s->%s() sets handler for signal \"%s\".\n",
				(gchar*)__FILE__,
				(gchar*)__FUNCTION__,
				signal
			       );
			LOGS("Bookmark/%s->%s() Function at adress =  %d.\n",
				(gchar*)__FILE__,
				(gchar*)__FUNCTION__,
				(guint)c_handler
			       );
			LOGS("Bookmark/%s->%s()     Data at adress =  %d.\n",
				(gchar*)__FILE__,
				(gchar*)__FUNCTION__,
				(guint)user_data
			       );
			return result;                        
		}
		else {
			g_warning("Bookmark/%s->%s() unsupported signal: %s.\n",
				  (gchar*)__FILE__,
				  (gchar*)__FUNCTION__,
				  signal
				 );
			return NULL;
		}
}






//==============================================================================
//==============================================================================
//==============================================================================
//---------------------------------------------------------- HELPFULLY FUNCTIONS
//==============================================================================

//------------------------------------------------------------------------------
static gchar* string_to_path(gchar** string) {
        LOGS("Bookmark/%s->%s() called.\n\
                 -->PARAM:string=\'%s\'\n",
                 (gchar*)__FILE__,
                 (gchar*)__FUNCTION__,
                 string[0]
               );
        gchar* arg = string[0];
        gchar* new = NULL;
        // cleaning from leading and trailing whitespaces
        g_strstrip(arg);        
         // add current directory if this is not absolute directory
        if (!g_path_is_absolute(arg)) {
                gchar* tmp = g_get_current_dir();
                new = g_strconcat(tmp,"/",arg,NULL);
                g_free(arg); arg = new; new = NULL;
        };
        // this is not a directory
        if (!g_file_test(arg, G_FILE_TEST_IS_DIR)) {        
                // if this is wrong filepath, string was wrong
                if (!g_file_test(arg, G_FILE_TEST_IS_REGULAR)) {        
                        g_free(arg);
                        new = NULL;
                }
                //if this is a file, remove filename
                else
                {   
                        new = g_path_get_dirname (arg);
                        g_free(arg);
                }
        }
        // this is a directory
        else {   
                // remove suffix "/" if neded...     
                if (g_str_has_suffix(arg,"/") ) {        
                        new = g_path_get_dirname (arg);
                        g_free(arg);
                }
                else {
                        new = arg;
                }
        };
        // now in new should be proper filepath, if not, string was wrong
        if (!g_file_test(new, G_FILE_TEST_IS_DIR))  {        
                // if that directory does not exist, passed string wasn't proper       
                g_free(new);
                new = NULL;
        };
        // replace string under passed address
        string[0] = new;
        LOGS("Bookmark/%s->%s() returned string=\'%s\'\n",
                (gchar*)__FILE__,
                (gchar*)__FUNCTION__,
                string[0]
               );
        return new;
}
//------------------------------------------------------------------------------
static double timer(gboolean start, gchar* message)
{
	static GArray* stack = NULL;
	static gboolean first_run = TRUE;
	static struct timeval actual_time;
	static struct timeval last_time;
	static struct timeval result;
	static double seconds = 0.0;
	if(first_run) {
		first_run = FALSE;
		stack = g_array_new(TRUE, TRUE, sizeof(struct timeval));
	};        

	if (start) {
		LOGS("Bookmark->%s() start timer for function '%s()'.\n",
			(gchar*)__FUNCTION__,
			message
		       );
		g_array_prepend_val(stack, actual_time);
		gettimeofday(&g_array_index(stack, struct timeval, 0),NULL);
		return -1.0;
	}
        // we just want to end some timer - print some information about 
        // working time;
	else {          
		gettimeofday(&actual_time,NULL);
		last_time = g_array_index(stack, struct timeval, 0);
		g_array_remove_index(stack, 0);

		if (actual_time.tv_usec < last_time.tv_usec) {
			int nsec = (last_time.tv_usec - actual_time.tv_usec) / 
					(1000000 + 1);
			last_time.tv_usec -= 1000000 * nsec;
			last_time.tv_sec += nsec;
		}
		if (actual_time.tv_usec - last_time.tv_usec > 1000000) {
			int nsec = (last_time.tv_usec - actual_time.tv_usec) / 
					1000000;
			last_time.tv_usec += 1000000 * nsec;
			last_time.tv_sec -= nsec;
		}
		result.tv_sec = actual_time.tv_sec - last_time.tv_sec;
		result.tv_usec = actual_time.tv_usec - last_time.tv_usec;
		seconds = (((double)(result.tv_usec)) / 1e6) +
				((double)(result.tv_sec));

		LOGS("Bookmark->%s() function \'%s()\' was working for: %g "
				"[s] or %ld [us].\n",
		(gchar*)__FUNCTION__,
		message,
		seconds,
		((long)(result.tv_sec*1e6)+(result.tv_usec))
		       );
                // stack is empty so we delete everything
		if(stack->len == 0)   
		{
			g_array_free(stack, TRUE);
			first_run = TRUE;
		}
	}
	return seconds;
}
//------------------------------------------------------------------------------



