/*******************************************************************************
This file is part of WhiteStork.

WhiteStork is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

WhiteStork is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with WhiteStork; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

Copyright 2006-2007 ComArch S.A.
*******************************************************************************/
#ifndef _WS_MANAGER_BOOKMARKS
#define _WS_MANAGER_BOOKMARKS

#include <ws_mng_searching_threads.h>
#include <ws_mng_gconf_utils.h>
#include <dictionary_engine.h>
#include <ws_mng_callbacks.h>
#include <ws_manager.h>


#ifdef __cplusplus
	extern "C" {
#endif

/**
 * Function used to add bookmarks
 * @param error error messages
 * @param param word and translation of word to adding
 * @param user_data structure holding nedded parameters
 */
void ws_mng_add_bookmark(GError *error, GArray* param, gpointer user_data);

/**
 * Function used to remove bookmarks
 * @param error error messages
 * @param param word and translation of word to remove
 * @param user_data structure holding nedded parameters
 */
void ws_mng_remove_bookmark(GError *error, GArray* param, gpointer user_data);

/**
 * Function used to load bookmark module 
 * @param data structure which holds the loaded module
 */
void ws_mng_load_bookmark(WSMngSearchData* data);

#ifdef __cplusplus
	}
#endif
#endif
