/*******************************************************************************
This file is part of WhiteStork.

WhiteStork is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

WhiteStork is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with WhiteStork; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

Copyright 2006-2007 ComArch S.A.
*******************************************************************************/
#ifndef _WS_MANAGER_DICTIONARY_UTILS
#define _WS_MANAGER_DICTIONARY_UTILS

#include <ws_mng_gconf_utils.h>
#include <dictionary_engine.h>
#include <ws_mng_callbacks.h>
#include <ws_manager.h>
#include <untar.h>


#ifdef __cplusplus
	extern "C" {
#endif

/** \brief Extracting compressed dictionary file
 *
 * @param error after excuting it contains error messages if any was
 * @param param parameters given by D-Bus
 * @param app_data manager data
 */
void ws_mng_extract_dictionary(GError *error, GArray* param, gpointer app_data);

/**
 * Function used to load dictionaries engines
 * @param dict_directory path to dictionaries 
 * @param data structure which contains all data of program
*/
void ws_mng_load_dict(GArray* dict_directory, WSMngSearchData* data);


#ifdef __cplusplus
	}
#endif
#endif
