/*******************************************************************************
This file is part of WhiteStork.

WhiteStork is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

WhiteStork is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with WhiteStork; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

Copyright 2006-2007 ComArch S.A.
*******************************************************************************/
#ifndef _WS_MANAGER_GCONF_UTILS
#define _WS_MANAGER_GCONF_UTILS

#include <gconf/gconf-client.h>
#include <gconf/gconf.h>
#include <ws_manager.h>

#ifdef __cplusplus
	extern "C" {
#endif

#define GCONF_KEY       "/apps/maemo/WhiteStork/Dictionaries"
#define GCONF_LIB_PATH  "/apps/maemo/WhiteStork/Engines"

/**
 *Function used to get the dictionaries location read fron GConf
 *@return path to dictionaries location
 */ 
GArray* ws_mng_read_gconf();

/**
 *Function used to get plugins location read from GConf
 *@return libraries location
 */
GArray* ws_mng_get_engines_location();


/**
 *Function used to get bookmark library location
 *@return path to bookmark location
 */
gchar* ws_mng_get_boomark_location();


/**
 *Function used to check if optimized flag in GConf is set
 *@param dict path to dictionary file
 *@return TRUE if dictionary is optimize, FALSE otherwise
 */
gboolean ws_mng_if_optimized(gchar* dict);

#ifdef __cplusplus
	}
#endif
#endif
