/*******************************************************************************
This file is part of WhiteStork.

WhiteStork is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

WhiteStork is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with WhiteStork; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

Copyright 2006-2007 ComArch S.A.
*******************************************************************************/
#ifndef _WS_MANAGER_THREADS_UTILS
#define _WS_MANAGER_THREADS_UTILS

#include <ws_manager.h>

#ifdef __cplusplus
	extern "C" {
#endif


struct _WSMngSearchAtom {
	WSMngSearchData *data;
	gchar           *word;
	GThread         *thread;

        GArray          *word_list;
        gchar           *trans;
};
typedef struct _WSMngSearchAtom WSMngSearchAtom;

/* functions for critical sections and thread handling  */
gboolean         try_lock_was_locked(WSMngSearchData* data, gchar* fun);
gboolean         is_rec_locked(GStaticRecMutex* m);
void             stop_if_needed(WSMngSearchAtom* data);
void             free_search_atom(WSMngSearchAtom* data);
WSMngSearchAtom *create_search_atom(WSMngSearchData* app_data, gchar* word);
#ifdef __cplusplus
	}
#endif
#endif
